// Code generated by go-swagger; DO NOT EDIT.

package p_cloud_s_a_p

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"

	models "github.com/IBM-Cloud/power-go-client/power/models"
)

// NewPcloudSapPostParams creates a new PcloudSapPostParams object
// with the default values initialized.
func NewPcloudSapPostParams() *PcloudSapPostParams {
	var ()
	return &PcloudSapPostParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewPcloudSapPostParamsWithTimeout creates a new PcloudSapPostParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewPcloudSapPostParamsWithTimeout(timeout time.Duration) *PcloudSapPostParams {
	var ()
	return &PcloudSapPostParams{

		timeout: timeout,
	}
}

// NewPcloudSapPostParamsWithContext creates a new PcloudSapPostParams object
// with the default values initialized, and the ability to set a context for a request
func NewPcloudSapPostParamsWithContext(ctx context.Context) *PcloudSapPostParams {
	var ()
	return &PcloudSapPostParams{

		Context: ctx,
	}
}

// NewPcloudSapPostParamsWithHTTPClient creates a new PcloudSapPostParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewPcloudSapPostParamsWithHTTPClient(client *http.Client) *PcloudSapPostParams {
	var ()
	return &PcloudSapPostParams{
		HTTPClient: client,
	}
}

/*PcloudSapPostParams contains all the parameters to send to the API endpoint
for the pcloud sap post operation typically these are written to a http.Request
*/
type PcloudSapPostParams struct {

	/*Body
	  Parameters for the creation of a new SAP PVM Instance

	*/
	Body *models.SAPCreate
	/*CloudInstanceID
	  Cloud Instance ID of a PCloud Instance

	*/
	CloudInstanceID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the pcloud sap post params
func (o *PcloudSapPostParams) WithTimeout(timeout time.Duration) *PcloudSapPostParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the pcloud sap post params
func (o *PcloudSapPostParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the pcloud sap post params
func (o *PcloudSapPostParams) WithContext(ctx context.Context) *PcloudSapPostParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the pcloud sap post params
func (o *PcloudSapPostParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the pcloud sap post params
func (o *PcloudSapPostParams) WithHTTPClient(client *http.Client) *PcloudSapPostParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the pcloud sap post params
func (o *PcloudSapPostParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the pcloud sap post params
func (o *PcloudSapPostParams) WithBody(body *models.SAPCreate) *PcloudSapPostParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the pcloud sap post params
func (o *PcloudSapPostParams) SetBody(body *models.SAPCreate) {
	o.Body = body
}

// WithCloudInstanceID adds the cloudInstanceID to the pcloud sap post params
func (o *PcloudSapPostParams) WithCloudInstanceID(cloudInstanceID string) *PcloudSapPostParams {
	o.SetCloudInstanceID(cloudInstanceID)
	return o
}

// SetCloudInstanceID adds the cloudInstanceId to the pcloud sap post params
func (o *PcloudSapPostParams) SetCloudInstanceID(cloudInstanceID string) {
	o.CloudInstanceID = cloudInstanceID
}

// WriteToRequest writes these params to a swagger request
func (o *PcloudSapPostParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	// path param cloud_instance_id
	if err := r.SetPathParam("cloud_instance_id", o.CloudInstanceID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
